(function ($, Drupal) {
  Drupal.behaviors.media_folder_droppable = {
    attach(context) {
      $(
        once('media-file-explorer-droppable', '#subfolders .folder', context),
      ).each(function () {
        $(this).draggable({
          revert: 'invalid',
          appendTo: 'body',
          containment: '#explorer',
          scroll: false,
          cursor: 'move',
          helper: 'clone',
          cursorAt: { top: 40, left: 20 },
        });

        if ($(this).hasClass('folder-folder')) {
          $(this).droppable({
            accept: '#subfolders .folder',
            classes: {
              'ui-droppable-active': 'droppable move-droppable',
            },
            drop(event, ui) {
              const toMove = [];
              const selected = $('#subfolders .folder.selected');
              selected.each(function () {
                const mid = $(this).attr('data-id');
                const type = $(this).hasClass('folder-file')
                  ? 'file'
                  : 'folder';
                toMove.push({ mid, type });
              });
              const target = $(event.currentTarget);
              const fid = target.attr('data-id');

              $(this).ajaxMove(fid, toMove);
            },
          });
        }
      });

      $(
        once(
          'media-file-navbar-droppable',
          '#navbar div.navbar-folder',
          context,
        ),
      ).each(function () {
        $(this).droppable({
          accept: '#subfolders .folder',
          classes: {
            'ui-droppable-active': 'droppable move-droppable',
          },
          drop(event, ui) {
            const toMove = [];
            const selected = $('#subfolders .folder.selected');
            selected.each(function () {
              const mid = $(this).attr('data-id');
              const type = $(this).hasClass('folder-file') ? 'file' : 'folder';
              toMove.push({ mid, type });
            });
            const target = $(event.target);
            const fid = target.attr('data-id');

            $(this).ajaxMove(fid, toMove);
          },
        });
      });
    },
  };
})(jQuery, Drupal);
