<?php

namespace Drupal\media_folder_management\Entity\Access;

use Drupal\Core\Entity\EntityAccessControlHandler;
use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Session\AccountInterface;
use Drupal\Core\Access\AccessResult;

/**
 * Defines the access control handler for the entity type.
 *
 * @see \Drupal\media_folder_management\Entity\MediaFolderFileType
 */
class MediaFolderFileTypeAccessControlHandler extends EntityAccessControlHandler {

  /**
   * {@inheritdoc}
   *
   * Prevent any action for now.
   */
  protected function checkAccess(EntityInterface $entity, $operation, AccountInterface $account) {

    return AccessResult::forbidden()->cachePerPermissions();
  }

  /**
   * {@inheritdoc}
   *
   * Prevent any action for now.
   */
  protected function checkCreateAccess(AccountInterface $account, array $context, $entity_bundle = NULL) {
    return AccessResult::forbidden()->cachePerPermissions();
  }

}
